require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.content.Context"
import "android.os.Vibrator"
import "android.content.Intent"
import "android.net.Uri"

carlos = {
  "Acceder al Tutorial", 
  "Descargar archivos desde Google Drive", 
  "Únete al Grupo de Tutoriales para Ciegos en WhatsApp"
}

local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(100)

local bienvenidaMensaje = [[¿Te interesaría utilizar la voz del famoso Creepypastero DrossRotzank y cuatro voces más de otros famosos en MultiTTS sin conexión? ¡Entonces estás en el lugar correcto!

Puedes acceder al tutorial en el siguiente botón que está a continuación. A un lado de ese botón, encontrarás otro para poder descargar los archivos desde Google Drive.

Atentamente,
Carlos Cázares]]

layout = {
  LinearLayout,
  orientation = LinearLayout.VERTICAL,
  backgroundColor = "#000000", -- Fondo negro
  {
    TextView,
    text = "¡Usa la Voz del Creepypastero DrossRotzank como Motor de Voz y Cuatro Voces Famosas Más! 🎤✨",
    textSize = "20sp",
    gravity = 17,
    padding = "16dp",
    textColor = "#FFFFFF", -- Letras blancas
  },
  {
    TextView,
    text = bienvenidaMensaje,
    textSize = "16sp",
    gravity = 17,
    padding = "16dp",
    textColor = "#FFFFFF", -- Letras blancas
  },
  {
    LinearLayout, -- Contenedor para los botones
    orientation = LinearLayout.VERTICAL,
    layout_width = "fill",
    layout_height = "fill",
    {
      GridView,
      id = "grid",
      numColumns = 1,
      layout_width = "fill",
      layout_height = "0dp",
      layout_weight = 1, -- Utiliza todo el espacio disponible
      backgroundColor = "#333333", -- Fondo de los botones gris oscuro
    },
    {
      Button,
      text = "Volver",
      onClick = function(view)
        dlg.dismiss()
        vibrator.vibrate(100)
      end,
      layout_width = "wrap_content",
      gravity = 5,
      backgroundColor = "#555555", -- Fondo gris de los botones
      textColor = "#FFFFFF", -- Letras blancas en los botones
    },
  },
}

dlg = LuaDialog(service)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(carlos))

grid.onItemClick = function(l, v)
  task(100, function()
    dlg.dismiss()
    local context = activity or service
    vibrator.vibrate(100)
    service.playSoundTick()

    if v.text == carlos[1] then
      openLink("https://youtu.be/ipC-umKLwH8?si=3mrQFo-KTPPlFYvg")
    elseif v.text == carlos[2] then
      openLink("https://drive.google.com/drive/folders/1PJLwCQNcL3oFliP8QX-P1IbPc1V2HNwC")
    elseif v.text == carlos[3] then
      openLink("https://chat.whatsapp.com/KPxdX5LWWkAKjQL8wqLtVJ")
    end
  end)
end

function openLink(url)
  local intent = Intent(Intent.ACTION_VIEW)
  intent.setData(Uri.parse(url))
  context.startActivity(intent)
  service.asyncSpeak("El enlace se ha abierto.")
end

dlg.show()

function onKeyDown(code, event)
  if code == KeyEvent.KEYCODE_BACK then
    dlg.dismiss()
    return true
  end
end  

return true